#property copyright "Copyright  2012, Avatara@bigmir.net"
//     
//    
// (- )
#property show_inputs

extern string SSymbol="";
extern int ExtPeriodMultiplier=2; // new period multiplier factor
extern int N=50000;
extern double startPos=10.0,Sigma=40.0;
extern bool xFile=false;
int        ExtHandle=-1;
double Pi=3.1415926535,X1,X2,S,U,U1,U2; 
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
   int    i, start_pos, i_time, time0, last_fpos, periodseconds;
   double d_open, d_low, d_high, d_close, d_volume, last_volume;
   int    hwnd=0,cnt=0;
  
//---- History header
   int    version=400;
   string c_copyright;
   string c_symbol=Symbol();//SSymbol;
   int    i_period=Period()*ExtPeriodMultiplier;
   int    i_digits=Digits;
   int    i_unused[13],RND;
//---- 
   if (SSymbol!="") c_symbol=SSymbol;
  if (xFile) ExtHandle=FileOpen(c_symbol+i_period+".txt",
                        FILE_CSV|FILE_WRITE,";");
   else ExtHandle=FileOpenHistory(c_symbol+i_period+".hst",
                        FILE_BIN|FILE_WRITE); 
   if(ExtHandle < 0) return(-1);
//---- write history file header
   c_copyright="(C)opyright 2003, MetaQuotes Software Corp.";
 if (!xFile) {
   FileWriteInteger(ExtHandle, version, LONG_VALUE);
   FileWriteString(ExtHandle, c_copyright, 64);
   FileWriteString(ExtHandle, c_symbol, 12);
   FileWriteInteger(ExtHandle, i_period, LONG_VALUE);
   FileWriteInteger(ExtHandle, i_digits, LONG_VALUE);
   FileWriteInteger(ExtHandle, 0, LONG_VALUE);       //timesign
   FileWriteInteger(ExtHandle, 0, LONG_VALUE);       //last_sync
   FileWriteArray(ExtHandle, i_unused, 0, 13);
//---- write history file
    }
   periodseconds=i_period*60;
   
   d_close=startPos;
   
   MathSrand(TimeLocal());
   //---- normalize open time
   i_time=(TimeLocal()-N*periodseconds)/periodseconds;
   i_time*=periodseconds;
   while (cnt<N)
     { 
      while (G_Norm()){}  
      //----

      if (!xFile)
      {
      i_time+=periodseconds;
      if (TimeDayOfWeek(i_time)==0 || TimeDayOfWeek(i_time)==6) continue;
         d_open=d_close;
         d_close+=NormalizeDouble(Sigma*Point*(U1),
                 Digits);
         if (d_close<0.5) d_close=0.5;
         if (d_close>d_open) d_low=d_open-0.8*Sigma*Point;
                  else d_low=d_close-0.2*Sigma*Point;
         if (d_close>d_open) d_high=d_close+0.6*Sigma*Point;
                  else d_high=d_open+0.1*Sigma*Point;
         d_volume=1+S*10.0;
         
         FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
         FileWriteDouble(ExtHandle, d_open, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_low, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_high, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_close, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_volume, DOUBLE_VALUE);
        
         i_time+=periodseconds;
         
         d_open=d_close;
         d_close+=NormalizeDouble(Sigma*Point*(U2),
                 Digits);
         if (d_close<0.5) d_close=0.5;
         if (d_close>d_open) d_low=d_open-0.7*Sigma*Point;
                  else d_low=d_close-0.1*Sigma*Point;
         if (d_close>d_open) d_high=d_close+0.7*Sigma*Point;
                  else d_high=d_open+0.2*Sigma*Point;
         d_volume=2+S*10.0;
        
         FileWriteInteger(ExtHandle, i_time, LONG_VALUE);
         FileWriteDouble(ExtHandle, d_open, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_low, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_high, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_close, DOUBLE_VALUE);
         FileWriteDouble(ExtHandle, d_volume, DOUBLE_VALUE);
         FileFlush(ExtHandle);
         } 
         else 
         {
         FileWrite(ExtHandle,cnt,NormalizeDouble(Sigma*Point*(U1),
                  Digits));
         FileWrite(ExtHandle,cnt+1,NormalizeDouble(Sigma*Point*(U2),
                  Digits));
         }  
         cnt=cnt+2;
     } 
   
   Print(cnt," record(s) written");

   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void deinit()
  {
   if(ExtHandle>=0) { FileClose(ExtHandle); ExtHandle=-1; }
  }
//+------------------------------------------------------------------+
bool G_Norm(){
int I1,I2;
I1=MathRand();I2=MathRand();
X1=2*I1/32767.0-1.0;
X2=2*I2/32767.0-1.0;
S=X1*X1+X2*X2;     
 if (S>=1) return (true);
U=MathSqrt(-2.0*MathLog(S)/S);
U1=X1*U;
U2=X2*U;
 
return (false);
}